From 6c0a5722641ce0bad583279986edf8f7bc768354 Mon Sep 17 00:00:00 2001
From: Rainer Gerhards <rgerhards@adiscon.com>
Date: Tue, 6 Mar 2018 15:49:27 +0100
Subject: [PATCH 1/7] imfile: large refactoring of complete module

This commit greatly refactors imfile internal workings. It changes the
handling of inotify, FEN, and polling modes. Mostly unchanged is the
processing of the way a file is read and state files are kept.

This is about a 50% rewrite of the module.

Polling, inotify, and FEN modes now use greatly unified code. Some
differences still exists and may be changed with further commits. The
internal handling of wildcards and file detection has been completely
re-written from scratch. For example, previously when multi-level
wildcards were used these were not reliably detected. The code also
now provides much of the same functionality in all modes, most importantly
wildcards are now also supported in polling mode.

The refactoring sets ground for further enhancements and smaller
refactorings. This commit provides the same feature set that imfile
had previously and all existing CI tests pass, as do some newly
created tests.

Some specific changes:
- bugfix: module parameter "sortfiles" ignored
  This parameter only works in Solaris FEN mode, but is otherwise
  ignored.  Most importantly it is ignored under Linux.
  fixes https://github.com/rsyslog/rsyslog/issues/2528
- bugfix: imfile did not pick up all files when not present
  at startup
  fixes https://github.com/rsyslog/rsyslog/issues/2241
  fixes https://github.com/rsyslog/rsyslog/issues/2230
  fixes https://github.com/rsyslog/rsyslog/issues/2354
- bugfix: directories only support "*" wildcard, no others
  fixes https://github.com/rsyslog/rsyslog/issues/2303
- bugfix: parameter "sortfiles" did only work in FEN mode
  fixes https://github.com/rsyslog/rsyslog/issues/2528
- provides the ability to dynamically add and remove files via
  multi-level wildcards
  see also https://github.com/rsyslog/rsyslog/issues/1280
- the state file name currently has been changed to inode number
  This will further be worked on in upcoming PRs
  see also https://github.com/rsyslog/rsyslog/issues/2231
- some enhancements were also done to CI tests, most importantly
  they were made more compatibile with BSD

Note that most of the mentioned bug fixes cannot be applied to older
versions, as they fix design issues which are solved by the refactoring.
Thus there are not separate commits for them.

Distro maintainers: you need to decide to apply this patch as whole
or not. Believe me, it is not worth the effort to try to extract
specific patches from this commit. There is a good reason we do
not have multiple commits.

closes https://github.com/rsyslog/rsyslog/issues/2359

(cherry picked from commit ab1bd8c01b94d184125cbccb897b9319253a0a5b)
---
 IMFILE                                            |  131 +
 plugins/imfile/imfile.c                           | 3194 +++++++--------------
 tests/Makefile.am                                 |   22 +-
 tests/diag.sh                                     |   39 +-
 tests/imfile-discard-truncated-line.sh            |    2 +-
 tests/imfile-endregex-save-lf-persist.sh          |    2 +-
 tests/imfile-endregex-save-lf.sh                  |    2 +-
 tests/imfile-endregex-timeout-none.sh             |    4 +-
 tests/imfile-endregex-timeout-with-shutdown.sh    |    2 +-
 tests/imfile-endregex-timeout.sh                  |    2 +-
 tests/imfile-file-not-found-error.sh              |    4 +-
 tests/imfile-readmode2-with-persists.sh           |    4 +
 tests/imfile-readmode2.sh                         |   37 +-
 tests/imfile-rename-while-stopped.sh              |   33 +
 tests/imfile-rename.sh                            |   12 +-
 tests/imfile-truncate-line.sh                     |    2 +-
 tests/imfile-wildcards-dirs-multi.sh              |    2 +-
 tests/imfile-wildcards-dirs-multi2.sh             |    3 +-
 tests/imfile-wildcards-dirs-multi3.sh             |    5 +-
 tests/imfile-wildcards-dirs-multi4.sh             |    4 +-
 tests/imfile-wildcards-dirs-multi5-polling.sh     |   77 +
 tests/imfile-wildcards-dirs-multi5.sh             |   82 +
 tests/imfile-wildcards-dirs.sh                    |    2 +-
 tests/imfile-wildcards.sh                         |   32 +-
 tests/testsuites/imfile-wildcards-dirs-multi.conf |    2 +
 tests/testsuites/imfile-wildcards.conf            |   39 -
 26 files changed, 1517 insertions(+), 2223 deletions(-)
 create mode 100644 IMFILE
 create mode 100755 tests/imfile-rename-while-stopped.sh
 create mode 100755 tests/imfile-wildcards-dirs-multi5-polling.sh
 create mode 100755 tests/imfile-wildcards-dirs-multi5.sh
 delete mode 100644 tests/testsuites/imfile-wildcards.conf

diff --git a/IMFILE b/IMFILE
new file mode 100644
index 000000000..e960dd35b
--- /dev/null
+++ b/IMFILE
@@ -0,0 +1,131 @@
+Use Cases
+---------
+
+Monitor:
+[M1] /dir/*/*.log ; tag="monitor1"
+[M2] /dir/abc/a.* ; tag="monitor2"
+[M3] /dir/*/a/*.txt ; tag="monitor3"
+[M4] /di?/*/b/*.txt ; tag="monitor4"
+
+- if a.log is created, we have kind of a conflict: create two monitors then?
+  (sounds best so far)
+- /dir/abc may not initially exist, but later on created
+  -> same problem for any path depth (polling? multiple inotify? fail?)
+
+Let's assume /dir/abc exist, but nothing else under /dir
+
+Setup initial inotify:
+/dir  [M1]
+/dir  [M3]
+/dir/abc [M1]
+/dir/abc [M2]
+/dir/abc [M3]
+/dir/abc [M4]
+Rule? The parent of each component must be monitored
+/ [M4] -- really??? Means we need to monitor whole FS tree!
+/dir [M2] - /dir/abc may not yet exists but may be created later on
+
+Q: can we combine /dir/abc?
+A: well, we need to know what shall be monitored. e.g.
+
+/dir/abc/a.logfile is created
+watch /dir/abc must be evaluated
+does not match [M1], but [M2]!
+Event for /dir/abc is generated
+   need to check [M1], [M2]
+
+/dir/def is created
+watch /dir must be evaluated --> [M1], [M2], [M3], [M4] must be checked
+matches [M1],[M3],[M4]
+   create new watch
+   /dir/def [M1, M3, M4] - this watch should not exist if all is right [-> assert()]
+
+/dir/def/new.log is created
+watch /dir/def must be evaluated --> [M1, M3, M4]
+   create new file watch
+   /dir/def/new.log [M1]
+
+/dir/abc/a.log is created
+watch /dir/abc must be evaluated --> [M1, M2, M3, M4]
+   create new file watch
+   /dir/abc/a.log [M1, M2]
+
+At each level, I must know which child components to watch out for, and which
+monitor/listener they belong to. Comparison must be done on immediate-child level.
+
+Data Structures
+--------------
+
+Monitors
+........
+- path needs to be split into individial components --> array
+
+File Watches
+............
+- contains active file state
+- one file watch per file per monitor (/dir/abc/a.log sample with two active file entries)
+- multiple entries are not properly supported by inotify (and possibly FEN)
+  --> need to multiplex ourselfes based on single notifcation 
+
+Dir Watches
+...........
+- contains active directory state
+- used to discover new to-be-monitored files
+
+Problems
+--------
+- we need to find, for each level, the proper "next component" that we need to check
+  against (fnmatch on component?)
+- this must be done om a per-monitor basis
+- one entry per monitored file, but a list of monitors (and component names to check against)
+  --> how do we efficiently describe the monitor so that we can do an O(1) name comparison?
+  --> we can NOT assume that the full path matches, just component-by-component!
+  --> we may NOT get notifications if path level are rapidly created, as we may not
+      have setup the watch sufficiently fast - so we need to poll the full tree
+      in any case
+
+- state files: different state if the same file is monitored by more than one monitor
+  --> or should we flag this as an error case?
+
+Poll vs. Watch
+--------------
+Polling is always needed (due to watch racieness). So it probably is best to have some generic
+poll code, and use watches just to reduce the amount of polling. That also means that
+poll mode can do exactly the same the notification mode can do!
+
+
+Procedures
+----------
+
+e.g. /dir/aaa is created
+this will be reported on /dir watch, which is watched by all 4 monitors
+foreach monitor:
+   check if next-level component matches - this is the case for [M1, M2, M3]
+   if so:
+       create new/update existing entry (existing for all but first!)
+       arm watch for this entry (if newly created)
+       do a full poll of that entry and its subentries
+           AS FAR AS THE MONITOR IN QUESTION is affected:
+	   M1 will scan subdir for "*.log"
+	   M2 will scan for "abc", if it exists scan for "a.*"
+	   M3 will scan for "a", if it exists scan for "*.txt"
+	   --> rest of the path components need to be scanned, files
+	       processed for each monitor
+	       this is a recursive function
+
+The above-mentioned poll process is fundamental, and can occur on each level
+of the file system/monitor definitions. It needs to work both on active monitors as well
+as the configured path components. Does ist make sense to have them in a single structure?
+Is a tree more useful than an dirs table?
+
+now the opposite:
+e.g. /dir/aaa is deleted
+this will be reported on /dir watch, which is watched by all 4 monitors
+check if "aaa" exists as active(dynamic) entry
+if so:
+	check for sub-entries, initiate delete events if any exists
+	(TODO: is MOVE here a problem?)
+	delete "aaa" entry
+	Note: we MUST NOT remove entries that are statically configured
+	(e.g. /dir in our samples, even if it is deleted - it may re-appear)
+      
diff --git a/plugins/imfile/imfile.c b/plugins/imfile/imfile.c
index 950b62918..a5d20823f 100644
--- a/plugins/imfile/imfile.c
+++ b/plugins/imfile/imfile.c
@@ -5,7 +5,7 @@
  *
  * Work originally begun on 2008-02-01 by Rainer Gerhards
  *
- * Copyright 2008-2017 Adiscon GmbH.
+ * Copyright 2008-2018 Adiscon GmbH.
  *
  * This file is part of rsyslog.
  *
@@ -61,8 +61,9 @@
 #include "stringbuf.h"
 #include "ruleset.h"
 #include "ratelimit.h"
+#include "parserif.h"
 
-#include <regex.h> // TODO: fix via own module
+#include <regex.h>
 
 MODULE_TYPE_INPUT	/* must be present for input modules, do not remove */
 MODULE_TYPE_NOKEEP
@@ -81,11 +82,7 @@ static int bLegacyCnfModGlobalsPermitted;/* are legacy module-global config para
 
 #define NUM_MULTISUB 1024 /* default max number of submits */
 #define DFLT_PollInterval 10
-
-#define INIT_FILE_TAB_SIZE 4 /* default file table size - is extended as needed, use 2^x value */
-#define INIT_FILE_IN_DIR_TAB_SIZE 1 /* initial size for "associated files tab" in directory table */
 #define INIT_WDMAP_TAB_SIZE 1 /* default wdMap table size - is extended as needed, use 2^x value */
-
 #define ADD_METADATA_UNSPECIFIED -1
 
 /*
@@ -102,54 +99,6 @@ static int bLegacyCnfModGlobalsPermitted;/* are legacy module-global config para
 	#define GLOB_BRACE 0
 #endif
 
-/* this structure is used in pure polling mode as well one of the support
- * structures for inotify.
- */
-typedef struct lstn_s {
-	struct lstn_s *next, *prev;
-	struct lstn_s *masterLstn;/* if dynamic file (via wildcard), this points to the configured
-				 * master entry. For master entries, it is always NULL. Only
-				 * dynamic files can be deleted from the "files" list. */
-	uchar *pszFileName;
-	uchar *pszDirName;
-	uchar *pszBaseName;
-	uchar *pszTag;
-	size_t lenTag;
-	uchar *pszStateFile; /* file in which state between runs is to be stored (dynamic if NULL) */
-	int readTimeout;
-	int iFacility;
-	int iSeverity;
-	int maxLinesAtOnce;
-	uint32_t trimLineOverBytes;
-	int nRecords; /**< How many records did we process before persisting the stream? */
-	int iPersistStateInterval; /**< how often should state be persisted? (0=on close only) */
-	strm_t *pStrm;	/* its stream (NULL if not assigned) */
-	sbool bRMStateOnDel;
-	sbool hasWildcard;
-	uint8_t readMode;	/* which mode to use in ReadMultiLine call? */
-	uchar *startRegex;	/* regex that signifies end of message (NULL if unset) */
-	sbool discardTruncatedMsg;
-	sbool msgDiscardingError;
-	regex_t end_preg;	/* compiled version of startRegex */
-	uchar *prevLineSegment;	/* previous line segment (in regex mode) */
-	sbool escapeLF;	/* escape LF inside the MSG content? */
-	sbool reopenOnTruncate;
-	sbool addMetadata;
-	sbool addCeeTag;
-	sbool freshStartTail; /* read from tail of file on fresh start? */
-	sbool fileNotFoundError;
-	ruleset_t *pRuleset;	/* ruleset to bind listener to (use system default if unspecified) */
-	ratelimit_t *ratelimiter;
-	multi_submit_t multiSub;
-#ifdef HAVE_INOTIFY_INIT
-	uchar* movedfrom_statefile;
-	__u32 movedfrom_cookie;
-#endif
-#if defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)
-	struct fileinfo *pfinf;
-	sbool bPortAssociated;
-#endif
-} lstn_t;
 
 static struct configSettings_s {
 	uchar *pszFileName;
@@ -170,6 +119,7 @@ struct instanceConf_s {
 	uchar *pszDirName;
 	uchar *pszFileBaseName;
 	uchar *pszTag;
+	size_t lenTag;
 	uchar *pszStateFile;
 	uchar *pszBindRuleset;
 	int nMultiSub;
@@ -180,6 +130,7 @@ struct instanceConf_s {
 	sbool bRMStateOnDel;
 	uint8_t readMode;
 	uchar *startRegex;
+	regex_t end_preg;	/* compiled version of startRegex */
 	sbool discardTruncatedMsg;
 	sbool msgDiscardingError;
 	sbool escapeLF;
@@ -195,9 +146,56 @@ struct instanceConf_s {
 };
 
 
+/* file system objects */
+typedef struct fs_edge_s fs_edge_t;
+typedef struct fs_node_s fs_node_t;
+typedef struct act_obj_s act_obj_t;
+struct act_obj_s {
+	act_obj_t *prev;
+	act_obj_t *next;
+	fs_edge_t *edge;	/* edge which this object belongs to */
+	char *name;		/* full path name of active object */
+	char *basename;		/* only basename */ //TODO: remove when refactoring rename support
+	//char *statefile;	/* base name of state file (for move operations) */
+	int wd;
+#if defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)
+	struct fileinfo *pfinf;
+	sbool bPortAssociated;
+	int is_deleted;	/* debugging: entry deleted? */
+#endif
+	time_t timeoutBase; /* what time to calculate the timeout against? */
+	/* file dynamic data */
+	int in_move;	/* workaround for inotify move: if set, state file must not be deleted */
+	ino_t ino;	/* current inode nbr */
+	strm_t *pStrm;	/* its stream (NULL if not assigned) */
+	int nRecords; /**< How many records did we process before persisting the stream? */
+	ratelimit_t *ratelimiter;
+	multi_submit_t multiSub;
+};
+struct fs_edge_s {
+	fs_node_t *parent;
+	fs_node_t *node;	/* node this edge points to */
+	fs_edge_t *next;
+	uchar *name;
+	uchar *path;
+	act_obj_t *active;
+	int is_file;
+	int ninst;	/* nbr of instances in instarr */
+	instanceConf_t **instarr;
+};
+struct fs_node_s {
+	fs_edge_t *edges;
+};
+
+
 /* forward definitions */
-static rsRetVal persistStrmState(lstn_t *pInfo);
+static rsRetVal persistStrmState(act_obj_t *);
 static rsRetVal resetConfigVariables(uchar __attribute__((unused)) *pp, void __attribute__((unused)) *pVal);
+static rsRetVal ATTR_NONNULL(1) pollFile(act_obj_t *act);
+static int ATTR_NONNULL() getBasename(uchar *const __restrict__ basen, uchar *const __restrict__ path);
+static void ATTR_NONNULL() act_obj_unlink(act_obj_t *const act);
+static uchar * ATTR_NONNULL(1, 2) getStateFileName(const act_obj_t *, uchar *, const size_t);
+static int ATTR_NONNULL() getFullStateFileName(const uchar *const, uchar *const pszout, const size_t ilenout);
 
 
 #define OPMODE_POLLING 0
@@ -211,70 +209,23 @@ struct modConfData_s {
 	int readTimeout;
 	int timeoutGranularity;		/* value in ms */
 	instanceConf_t *root, *tail;
-	lstn_t *pRootLstn;
-	lstn_t *pTailLstn;
+	fs_node_t *conf_tree;
 	uint8_t opMode;
 	sbool configSetViaV2Method;
 	sbool sortFiles;
+	sbool normalizePath;	/* normalize file system pathes (all start with root dir) */
 	sbool haveReadTimeouts;	/* use special processing if read timeouts exist */
+	sbool bHadFileData;	/* actually a global variable:
+				   1 - last call to pollFile() had data
+				   0 - last call to pollFile() had NO data
+				   Must be manually reset to 0 if desired. Helper for
+				   polling mode.
+				 */
 };
 static modConfData_t *loadModConf = NULL;/* modConf ptr to use for the current load process */
 static modConfData_t *runModConf = NULL;/* modConf ptr to use for the current load process */
 
 
-/* Dynamic File support for inotify / fen mode */
-/* we need to track directories */
-struct dirInfoFiles_s { /* associated files */
-	lstn_t *pLstn;
-	int refcnt;	/* due to inotify's async nature, we may have multiple
-			 * references to a single file inside our cache - e.g. when
-			 * inodes are removed, and the file name is re-created BUT another
-			 * process (like rsyslogd ;)) holds open the old inode.
-			 */
-};
-typedef struct dirInfoFiles_s dirInfoFiles_t;
-
-/* This structure is a dynamic table to track file entries */
-struct fileTable_s {
-	dirInfoFiles_t *listeners;
-	int currMax;
-	int allocMax;
-};
-typedef struct fileTable_s fileTable_t;
-
-/* The dirs table (defined below) contains one entry for each directory that
- * is to be monitored. For each directory, it contains array which point to
- * the associated *active* files as well as *configured* files. Note that
- * the configured files may currently not exist, but will be processed
- * when they are created.
- */
-struct dirInfo_s {
-	uchar *dirName;
-	uchar *dirNameBfWildCard;
-	sbool hasWildcard;
-/* TODO: check if following property are inotify only?*/
-	int bDirType;		/* Configured or dynamic */
-	fileTable_t active;	/* associated active files */
-	fileTable_t configured; /* associated configured files */
-	int rdiridx;		/* Root diridx helper property */
-#if defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)
-	struct fileinfo *pfinf;
-	sbool bPortAssociated;
-#endif
-};
-
-#if defined(HAVE_INOTIFY_INIT) || (defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE))
-/* needed for inotify / fen mode */
-typedef struct dirInfo_s dirInfo_t;
-static dirInfo_t *dirs = NULL;
-static int allocMaxDirs;
-static int currMaxDirs;
-#endif /* #if defined(HAVE_INOTIFY_INIT) || (defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)) --- */
-
-/* the following two macros are used to select the correct file table */
-#define ACTIVE_FILE 1
-#define CONFIGURED_FILE 0
-
 #ifdef HAVE_INOTIFY_INIT
 /* We need to map watch descriptors to our actual objects. Unfortunately, the
  * inotify API does not provide us with any cookie, so a simple O(1) algorithm
@@ -285,9 +236,7 @@ static int currMaxDirs;
  */
 struct wd_map_s {
 	int wd;		/* ascending sort key */
-	lstn_t *pLstn;	/* NULL, if this is a dir entry, otherwise pointer into listener(file) table */
-	int dirIdx;	/* index into dirs table, undefined if pLstn == NULL */
-	time_t timeoutBase; /* what time to calculate the timeout against? */
+	act_obj_t *act; /* point to related active object */
 };
 typedef struct wd_map_s wd_map_t;
 static wd_map_t *wdmap = NULL;
@@ -304,10 +253,6 @@ struct fileinfo {
 };
 
 static int glport; /* Static port handle for FEN api*/
-
-/* Need these function to be declared on top */
-static rsRetVal fen_DirSearchFiles(lstn_t *pLstn, int dirIdx);
-static rsRetVal fen_processEventDir(struct file_obj* fobjp, int dirIdx, int revents);
 #endif /* #if OS_SOLARIS -------------------------------------------------- */
 
 static prop_t *pInputName = NULL;
@@ -319,6 +264,7 @@ static struct cnfparamdescr modpdescr[] = {
 	{ "readtimeout", eCmdHdlrPositiveInt, 0 },
 	{ "timeoutgranularity", eCmdHdlrPositiveInt, 0 },
 	{ "sortfiles", eCmdHdlrBinary, 0 },
+	{ "normalizepath", eCmdHdlrBinary, 0 },
 	{ "mode", eCmdHdlrGetWord, 0 }
 };
 static struct cnfparamblk modpblk =
@@ -362,20 +308,32 @@ static struct cnfparamblk inppblk =
 #include "im-helper.h" /* must be included AFTER the type definitions! */
 
 
-#ifdef HAVE_INOTIFY_INIT
-/* support for inotify mode */
+#if 0 // Code we can potentially use for new functionality // TODO: use or remove
+//TODO add a kind of portable asprintf:
+static const char * ATTR_NONNULL()
+gen_full_name(const char *const dirname, const char *const name)
+{
+	const size_t len_full_name = strlen(dirname) + 1 + strlen(name) + 1;
+	char *const full_name = malloc(len_full_name);
+	if(full_name == NULL)
+		return NULL;
 
+	snprintf(full_name, len_full_name, "%s/%s", dirname, name);
+	return full_name;
+}
+#endif
 
+
+#ifdef HAVE_INOTIFY_INIT
 #if ULTRA_DEBUG == 1
-/* if ultra debugging enabled */
 static void
-dbg_wdmapPrint(char *msg)
+dbg_wdmapPrint(const char *msg)
 {
 	int i;
 	DBGPRINTF("%s\n", msg);
 	for(i = 0 ; i < nWdmap ; ++i)
-		DBGPRINTF("wdmap[%d]: wd: %d, file %d, dir %d\n", i,
-			  wdmap[i].wd, wdmap[i].fIdx, wdmap[i].dirIdx);
+		DBGPRINTF("wdmap[%d]: wd: %d, act %p, name: %s\n",
+			i, wdmap[i].wd, wdmap[i].act, wdmap[i].act->name);
 }
 #endif
 
@@ -391,58 +349,62 @@ finalize_it:
 	RETiRet;
 }
 
-/* looks up a wdmap entry by filename and returns it's index if found
- * or -1 if not found.
- */
-static int
-wdmapLookupFilename(uchar *pszFileName)
-{
-	int i = 0;
-	int wd = -1;
-	/* Loop through */
-	for(i = 0 ; i < nWdmap; ++i) {
-		if (	wdmap[i].pLstn != NULL &&
-			strcmp((const char*)wdmap[i].pLstn->pszFileName, (const char*)pszFileName) == 0){
-			/* Found matching wd */
-			wd = wdmap[i].wd;
-		}
-	}
-
-	return wd;
-}
 
-/* looks up a wdmap entry by pLstn pointer and returns it's index if found
- * or -1 if not found.
- */
-static int
-wdmapLookupListner(lstn_t* pLstn)
+/* note: we search backwards, as inotify tends to return increasing wd's */
+static rsRetVal
+wdmapAdd(int wd, act_obj_t *const act)
 {
-	int i = 0;
-	int wd = -1;
-	/* Loop through */
-	for(i = 0 ; i < nWdmap; ++i) {
-		if (wdmap[i].pLstn == pLstn)
-			wd = wdmap[i].wd;
+	wd_map_t *newmap;
+	int newmapsize;
+	int i;
+	DEFiRet;
+
+	for(i = nWdmap-1 ; i >= 0 && wdmap[i].wd > wd ; --i)
+		; 	/* just scan */
+	if(i >= 0 && wdmap[i].wd == wd) {
+		LogError(0, RS_RET_INTERNAL_ERROR, "imfile: wd %d already in wdmap!", wd);
+		ABORT_FINALIZE(RS_RET_FILE_ALREADY_IN_TABLE);
+	}
+	++i;
+	/* i now points to the entry that is to be moved upwards (or end of map) */
+	if(nWdmap == allocMaxWdmap) {
+		newmapsize = 2 * allocMaxWdmap;
+		CHKmalloc(newmap = realloc(wdmap, sizeof(wd_map_t) * newmapsize));
+		// TODO: handle the error more intelligently? At all possible? -- 2013-10-15
+		wdmap = newmap;
+		allocMaxWdmap = newmapsize;
+	}
+	if(i < nWdmap) {
+		/* we need to shift to make room for new entry */
+		memmove(wdmap + i + 1, wdmap + i, sizeof(wd_map_t) * (nWdmap - i));
 	}
+	wdmap[i].wd = wd;
+	wdmap[i].act = act;
+	++nWdmap;
+	DBGPRINTF("add wdmap[%d]: wd %d, act obj %p, path %s\n", i, wd, act, act->name);
 
-	return wd;
+finalize_it:
+	RETiRet;
 }
 
-/* looks up a wdmap entry by dirIdx and returns it's index if found
- * or -1 if not found.
- */
+/* return wd or -1 on error */
 static int
-wdmapLookupListnerIdx(const int dirIdx)
+in_setupWatch(act_obj_t *const act, const int is_file)
 {
-	int i = 0;
 	int wd = -1;
-	/* Loop through */
-	for(i = 0 ; i < nWdmap; ++i) {
-		if (wdmap[i].dirIdx == dirIdx)
-			wd = wdmap[i].wd;
-	}
+	if(runModConf->opMode != OPMODE_INOTIFY)
+		goto done;
 
-	return wd;
+	wd = inotify_add_watch(ino_fd, act->name,
+		(is_file) ? IN_MODIFY : IN_CREATE|IN_DELETE|IN_MOVED_FROM|IN_MOVED_TO);
+	if(wd < 0) {
+		LogError(errno, RS_RET_IO_ERROR, "imfile: cannot watch object '%s'",
+			act->name);
+		goto done;
+	}
+	wdmapAdd(wd, act);
+	DBGPRINTF("in_setupDirWatch: watch %d added for dir %s(%p)\n", wd, act->name, act);
+done:	return wd;
 }
 
 /* compare function for bsearch() */
@@ -467,45 +429,6 @@ wdmapLookup(int wd)
 	return bsearch(&wd, wdmap, nWdmap, sizeof(wd_map_t), wdmap_cmp);
 }
 
-/* note: we search backwards, as inotify tends to return increasing wd's */
-static rsRetVal
-wdmapAdd(int wd, const int dirIdx, lstn_t *const pLstn)
-{
-	wd_map_t *newmap;
-	int newmapsize;
-	int i;
-	DEFiRet;
-
-	for(i = nWdmap-1 ; i >= 0 && wdmap[i].wd > wd ; --i)
-		; 	/* just scan */
-	if(i >= 0 && wdmap[i].wd == wd) {
-		DBGPRINTF("wd %d already in wdmap!\n", wd);
-		ABORT_FINALIZE(RS_RET_FILE_ALREADY_IN_TABLE);
-	}
-	++i;
-	/* i now points to the entry that is to be moved upwards (or end of map) */
-	if(nWdmap == allocMaxWdmap) {
-		newmapsize = 2 * allocMaxWdmap;
-		CHKmalloc(newmap = realloc(wdmap, sizeof(wd_map_t) * newmapsize));
-		// TODO: handle the error more intelligently? At all possible? -- 2013-10-15
-		wdmap = newmap;
-		allocMaxWdmap = newmapsize;
-	}
-	if(i < nWdmap) {
-		/* we need to shift to make room for new entry */
-		memmove(wdmap + i + 1, wdmap + i, sizeof(wd_map_t) * (nWdmap - i));
-	}
-	wdmap[i].wd = wd;
-	wdmap[i].dirIdx = dirIdx;
-	wdmap[i].pLstn = pLstn;
-	++nWdmap;
-	DBGPRINTF("enter into wdmap[%d]: wd %d, dir %d, lstn %s:%s\n",i,wd,dirIdx,
-		  (pLstn == NULL) ? "DIRECTORY" : "FILE",
-	          (pLstn == NULL) ? dirs[dirIdx].dirName : pLstn->pszFileName);
-
-finalize_it:
-	RETiRet;
-}
 
 static rsRetVal
 wdmapDel(const int wd)
